#!/usr/bin/env bash

######################################################################

# longueur minimale pour le mot de passe
minlength=8

######################################################################

ed_file() {
	# fait l'equivalent de ed avec des extended regexp en version portable
	# (et oui, pas facile)
	f=$1
	shift
	r=""

	for i in "$@"
	do

		# considere que la regexp est en 2 parties: 
	        # le check de la ligne
       		# la commande de remplacement
        	check="`echo \"$i\" | cut -d'/' -f2`"
        	repl="`echo \"$i\" | cut -d'/' -f3-`"
	
		r="$r"'$l =~ '"$repl if (\$l =~ /$check/); "
	done

	cat $f | perl -e 'foreach my $l (<STDIN>) { chomp($l); '"$r"' print "$l\n" }' > $f.tmp
	mv -f $f.tmp $f
}

change_confopt () {
    echo "Options de configuration. Exemples:"
    echo " * --with-gmplib=/bahamut/lib/libgmp.a --with-gmpinc=/bahamut/include/gmp.h"
    echo " * --prefix=\$home"
    echo " * --disable-openssl"
    read -ep "Options de configuration: " confopt

    echo $confopt | grep -- '--disable-openssl' > /dev/null
    ssl=$?
}

change_cgi () {
    read -ep "Activer le support pour le CGI::IRC (o/n): " cgi
    case "$cgi" in
        (o*|y*) cgi="on";;
        (*)     cgi="off";;
    esac
}

change_cgiaddress () {
    read -ep "IP du CGI::IRC: " cgiaddress
}

change_spoofpass () {
    local length=0
    while [ $length -lt $minlength ]; do
        local spoofpass1="coin"
        local spoofpass2="pan"
        while [ $spoofpass1 != $spoofpass2 ]; do
            read -esp "Spoof password: " spoofpass1
            echo
            read -esp "Spoof password (confirmation): " spoofpass2
            [ $spoofpass1 != $spoofpass2 ] && echo "Mots de passe diffrents"
        done
        spoofpass=$spoofpass1
        length=$(echo -n "$spoofpass" | wc -c)
        [ $length -lt $minlength ] && echo "Mot de passe trop court"
    done
    echo
}

change_region () {
    read -ep "Rgion: " region
}

change_ville () {
    read -ep "Ville: " ville
}

change_ecoleunivfull () {
    read -ep "cole/universit (nom complet): " ecoleunivfull
}

change_ecoleunivshort () {
    read -ep "cole/universit (nom DNS en minuscules - ex : int): " ecoleunivshort
}

change_all () {
    change_confopt
    cgi="off"
    change_cgi
    if [ $cgi = "on" ]; then
        change_cgiaddress
        change_spoofpass
    fi
    if [ $ssl -eq 1 ]; then
        change_region
        change_ville
        change_ecoleunivfull
        change_ecoleunivshort
    fi
}

display_menu () {
    echo "Paramtres courants:"
    echo "(o)  Options de configuration: $confopt"
    echo "(c)  Support pour le CGI::IRC: $cgi"
    if [ $cgi = "on" ]; then
        echo "(ca) IP du CGI::IRC : $cgiaddress"
        echo "(sp) Spoof password : <*>"
    fi
    if [ $ssl -eq 1 ]; then
        echo "(r)  Rgion: $region"
        echo "(v)  Ville: $ville"
        echo "(N)  Nom complet de l'cole/universit: $ecoleunivfull"
        echo "(n)  Nom DNS de l'cole/universit: $ecoleunivshort"
    fi
    echo "(q)  Quitter sans configurer"
    echo "(x)  Configurer et quitter"
}

sur () {
    if [ $cgi = "on" -a -z "$cgiaddress" ]; then
        echo "Support pour CGI::IRC activ mais aucune adresse spcifie"
        return 1
    fi

    length=$(echo -n "$spoofpass" | wc -c)
    if [ $cgi = "on" -a $length -lt $minlength ]; then
        echo "Support pour CGI::IRC activ mais mot de passe de spoof non valide"
        return 1
    fi

    if [ $ssl -eq 1 -a -z "$region" ]; then
        echo "Support SSL activ mais aucune rgion spcifie"
        return 1
    fi

    if [ $ssl -eq 1 -a -z "$ville" ]; then
        echo "Support SSL activ mais aucune ville spcifie"
        return 1
    fi

    if [ $ssl -eq 1 -a -z "$ecoleunivfull" ]; then
        echo "Support SSL activ mais aucun nom d'cole ou d'universit spcifi"
        return 1
    fi

    if [ $ssl -eq 1 -a -z "$ecoleunivshort" ]; then
        echo "Support SSL activ mais aucun nom DNS spcifi"
        return 1
    fi

    [ -z "$confopt" ] && echo "Aucune option de configuration"

    local answer
    read -ep "tes-vous sr (o/n)? " answer
    case "$answer" in
         (o*|y*)
        return 0;;
    esac

    return 1
}

loop () {
    local done=false
    while ! "$done"; do
        local answer
        echo
        display_menu
        read -ep "Votre choix : " answer
        case "$answer" in
            (o) change_confopt;;
            (c) change_cgi;;
            (ca)
            if [ "$cgi" = "on" ]; then
                change_cgiaddress
            else
                echo "Mauvaise rponse"
            fi;;
            (sp)
            if [ "$cgi" = "on" ]; then
                change_spoofpass
            else
                echo "Mauvaise rponse"
            fi;;
            (r)
            if [ $ssl -eq 1 ]; then
                change_region
            else
                echo "Mauvaise rponse"
            fi;;
            (v)
            if [ $ssl -eq 1 ]; then
                change_ville
            else
                echo "Mauvaise rponse"
            fi;;
            (N)
            if [ $ssl -eq 1 ]; then
                change_ecoleunivfull
            else
                echo "Mauvaise rponse"
            fi;;
            (n)
            if [ $ssl -eq 1 ]; then
                change_ecoleunivshort
            else
                echo "Mauvaise rponse"
            fi;;
            (q) if sur; then exit 0; fi;;
            (x) if sur; then configurer; exit 0; fi;;
            (*) echo "Mauvaise rponse";;
        esac
    done
}

configurer () {
    ./configure $confopt || exit 0

    echo
    echo

    if [ $cgi = "on" ]; then
        ed_file "include/config.h" \
	  '/#(define|undef).*HOSTNAME_SPOOFING$/s/undef/define/' \
          '/#define HOSTNAME_SPOOFING_PWD/s/\"[^\"]*\"/\"'$spoofpass'\"/' \
          '/#(define|undef).*THROTTLE_IGNORE$/s/(define|undef)/define/' \
          '/#define THROTTLE_IGNORE_IP/s/\"[^\"]*\"/\"'$cgiaddress'\"/'
    else
	ed_file "include/config.h" \
          '/#(define|undef).*HOSTNAME_SPOOFING$/s/(define|undef)/undef/' \
          '/#define HOSTNAME_SPOOFING_PWD/s/\"[^\"]*\"/\"\"/' \
          '/#(define|undef).*THROTTLE_IGNORE$/s/(define|undef)/undef/' \
          '/#define THROTTLE_IGNORE_IP/s/\"[^\"]*\"/\"0.0.0.0\"/'
    fi

    if [ $? -ne 0 ]; then
        echo "Erreur lors de la modification de include/config.h"
        exit 1
    else
        echo "Le fichier include/config.h a t modifi."
    fi

    echo

    if [ $ssl -eq 1 ]; then
        cd ssl
        sh makecert.sh newcert > /dev/null 2>&1 <<EOF

$region
$ville

Serveur IRC RezoSup de l'$ecoleunivfull
irc.$ecoleunivshort.rezosup.org
EOF
        if [ $? -ne 0 ]; then
            echo "Erreur lors de la cration du certificat SSL"
            exit 2
        else
            echo "Le certificat SSL a t cr"
        fi

        cd - > /dev/null
    fi

    echo
    echo "Vous pouvez lancer make install."
    echo
}

change_all

loop
